// MSVC_TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MSVC_Test.h"
#include "MSVC_TestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMSVC_TestDlg dialog

CMSVC_TestDlg::CMSVC_TestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMSVC_TestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMSVC_TestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMSVC_TestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMSVC_TestDlg)
	DDX_Control(pDX, IDC_SOUNDREC1, m_SoundRec);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMSVC_TestDlg, CDialog)
	//{{AFX_MSG_MAP(CMSVC_TestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_CODEC, OnButtonCodec)
	ON_BN_CLICKED(IDC_BUTTON_PROPERTIES, OnButtonProperties)
	ON_BN_CLICKED(IDC_BUTTON_ABOUT, OnButtonAbout)
	ON_EN_KILLFOCUS(IDC_EDIT_FILE, OnKillfocusEditFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMSVC_TestDlg message handlers

BOOL CMSVC_TestDlg::OnInitDialog()
{	CDialog::OnInitDialog();
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CString File;
	File = m_SoundRec.GetFileName();
	SetDlgItemText(IDC_EDIT_FILE, File);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMSVC_TestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMSVC_TestDlg::OnQueryDragIcon()
{	return (HCURSOR) m_hIcon;
}

void CMSVC_TestDlg::OnButtonStart() 
{	m_SoundRec.Start();
}

void CMSVC_TestDlg::OnButtonStop() 
{	m_SoundRec.Stop();
}

BEGIN_EVENTSINK_MAP(CMSVC_TestDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CMSVC_TestDlg)
	ON_EVENT(CMSVC_TestDlg, IDC_SOUNDREC1, 115 /* OnStarted */, OnOnStartedSoundrec, VTS_NONE)
	ON_EVENT(CMSVC_TestDlg, IDC_SOUNDREC1, 116 /* OnStopped */, OnOnStoppedSoundrec, VTS_NONE)
	ON_EVENT(CMSVC_TestDlg, IDC_SOUNDREC1, 114 /* OnAudioVolume */, OnOnAudioVolumeSoundrec, VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CMSVC_TestDlg::OnOnStartedSoundrec() 
{	SetDlgItemText(IDC_STATUS, "Started");
}

void CMSVC_TestDlg::OnOnStoppedSoundrec() 
{	SetDlgItemText(IDC_STATUS, "Stopped");
}

void CMSVC_TestDlg::OnOnAudioVolumeSoundrec(long AudioVolume) 
{	char s[64];
	SetDlgItemText(IDC_VOLUME, ltoa(AudioVolume,s,10));
}

void CMSVC_TestDlg::OnButtonCodec() 
{	m_SoundRec.ChooseCodec();
}

void CMSVC_TestDlg::OnButtonProperties() 
{	m_SoundRec.Properties();
}

void CMSVC_TestDlg::OnButtonAbout() 
{	m_SoundRec.AboutBox();
}

void CMSVC_TestDlg::OnKillfocusEditFile() 
{	char s[MAX_PATH];
	GetDlgItemText(IDC_EDIT_FILE, s, sizeof(s));
	m_SoundRec.SetFileName(s);
}
